; Appendix 5\cr_tb.lsp
;  N.Poleshchuk, 2006
; Based on the book: N.Poleshchuk, P.Loskutov
;"AutoLISP and Visual LISP Inside AutoCAD"
; ("BHV-Petersburg" Publishing House, 2006)
;
; Listing 1. File cr_tb.lsp
;

(defun cr_tb (g_name t_name l_names l_helps l_macros
  l_icons cx cy nrows / wbOK mgs mg tbs tb i tbitem)
(vl-load-com)
(setq mgs (vla-get-MenuGroups (vlax-get-acad-object)))
(if (= (type g_name) 'STR)
  (setq wbOK (if mgs T nil)))
(if wbOK
  (progn
; If there is no such group: Automation Error. Invalid argument XXX in Item
    (setq mg (vl-catch-all-apply 'vla-Item (list mgs g_name)))
    (if (/= (type mg) 'VLA-OBJECT)
      (progn
	(setq wbOK nil)
        (princ "\nGroup name is invalid. ")
      );progn
    );if
  );progn
);if

; Group name is valid
; Check if there is already toolbar with the same name
(if wbOK
  (progn
    (if (= (type t_name) 'STR)
      (progn
        (setq tbs (vla-get-Toolbars mg))
	; If there is no such toolbar: Automation Error. Invalid argument XXX in Item
        (setq tb (vl-catch-all-apply 'vla-Item (list tbs t_name)))
        (if (not (vl-catch-all-error-p tb))
	  (progn
	    (setq wbOK nil); name already exists
            (princ "\nToolbar name is already used. ")
	  );progn
        );if
      );progn
      (progn
	(setq wbOK nil)
        (princ "\nToolbar name is invalid. ")
      );progn
    );if
  );progn
);if

; Toolbar name is valid. We create new toolbar
(if wbOK
  (progn
    (setq tb (vla-Add tbs t_name))
    (if tb
      (progn
    ; Add buttons and icon pictures
    ; It is necessary to add check for list arguments
	(setq i -1)
	(repeat (length l_names)
	  (setq i (1+ i))
          (setq tbitem (vla-AddToolbarButton tb
     i (nth i l_names) (nth i l_helps) (nth i l_macros))); button i
	  (vla-SetBitmaps tbitem (nth i l_icons) (nth i l_icons))
	);repeat
	; Toolbar coordinates and number of rows
	(vla-Float tb cx cy nrows)
        (princ (strcat "\nToolbar " t_name
          " is created in the group " g_name ". "))
	(setq g_tb tb); save in global variable
                      ; for future use
        (vlr-beep-reaction); beep sound
      );progn
      (princ (strcat "\nToolbar " t_name
        " already exists in the group " g_name ". "))
    );if
  );progn
);if
; Release memory for unnecessary VLA objects
(mapcar (function (lambda (x)
  (if (and x (not (vlax-object-released-p x)))
    (vlax-release-object x)))) (list mgs mg tbs tbitem))
(princ)
);defun cr_tb

